<template>
  <UserCenter :title="$t('withdrawal')">
    <div v-if="isLoading" class="flex w-full h-full">
      <div v-loading="isLoading" class="w-full px-5 py-32"></div>
    </div>
    <template v-else>
      <div
        v-if="!isBankMethodAvailabled"
        class="px-5 py-32 text-2xl flex justify-center"
      >
        <span>{{ $t("no_available_method_to_do_the_transaction") }}</span>
      </div>
      <template v-else>
        <div
          v-if="!isLoading && !isShowPaymentPasswordDialog"
          class="flex divider-x relative mx-auto customePeru"
        >
          <div class="horizonal-line">
            <aside class="min-w-[248px] w-full show_hidden_button_right">
              <el-scrollbar>
                <div class="p-6 flex flex-col gap-4">
                  <nuxt-link
                    v-if="isNormalBankMethodValible && isUfun"
                    to="/withdrawal/bank-transfer"
                    active-class="selected"
                  >
                    <ui-check-button
                      :text="$t('bank_transfer')"
                      :img="
                        getAssetImage(
                          'assets/materials/paymentMethod/icon-bank-transfer@2x.png'
                        )
                      "
                    />
                  </nuxt-link>
                  <template v-if="isPaymentBankMethodValible">
                    <nuxt-link
                      v-for="paymentMethod in paymentBanks.PaymentMethodsForWithdrawal"
                      :key="paymentMethod.PaymentMethodId"
                      :to="
                        '/withdrawal/payment-bank/' +
                        paymentMethod.PaymentMethod
                      "
                      active-class="selected"
                    >
                      <ui-check-button
                        :text="paymentMethod.PaymentMethodDisplayName"
                        :img="paymentMethod.PaymentMethodIconUrl"
                      />
                    </nuxt-link>
                  </template>
                  <nuxt-link
                    v-if="isNormalBankMethodValible && !isUfun"
                    to="/withdrawal/bank-transfer"
                    active-class="selected"
                  >
                    <ui-check-button
                      :text="$t('bank_transfer')"
                      :img="
                        getAssetImage(
                          'assets/materials/paymentMethod/icon-bank-transfer@2x.png'
                        )
                      "
                    />
                  </nuxt-link>
                </div>
              </el-scrollbar>
            </aside>
          </div>

          <el-scrollbar class="w-full h-screen overflow-y-auto">
            <div
              class="show_hidden_button_left cus_check_button"
              style="overflow: unset"
            >
              <div class="flex w-full menu-header gap-4">
                <nuxt-link
                  v-if="isNormalBankMethodValible && isUfun"
                  to="/withdrawal/bank-transfer"
                  active-class="selected"
                >
                  <ui-check-button
                    :text="$t('bank_transfer')"
                    :img="
                      getAssetImage(
                        'assets/materials/paymentMethod/icon-bank-transfer@2x.png'
                      )
                    "
                  />
                </nuxt-link>
                <template v-if="isPaymentBankMethodValible">
                  <nuxt-link
                    v-for="paymentMethod in paymentBanks.PaymentMethodsForWithdrawal"
                    :key="paymentMethod.PaymentMethodId"
                    :to="
                      '/withdrawal/payment-bank/' + paymentMethod.PaymentMethod
                    "
                    active-class="selected"
                  >
                    <ui-check-button
                      :text="paymentMethod.PaymentMethodDisplayName"
                      :img="paymentMethod.PaymentMethodIconUrl"
                    />
                  </nuxt-link>
                </template>
                <nuxt-link
                  v-if="isNormalBankMethodValible && !isUfun"
                  to="/withdrawal/bank-transfer"
                  active-class="selected"
                >
                  <ui-check-button
                    :text="$t('bank_transfer')"
                    :img="
                      getAssetImage(
                        'assets/materials/paymentMethod/icon-bank-transfer@2x.png'
                      )
                    "
                  />
                </nuxt-link>
              </div>
            </div>
            <div class="divider-y">
              <nuxt-page
                :payment-banks="paymentBanks"
                :normal-banks="normalBanks"
                :profile="profile"
                :is-withdrawal-limit-enabled="isWithdrawalLimitEnabled"
                :is-payment-password-enable="isPaymentPasswordEnable"
              >
              </nuxt-page>
            </div>
          </el-scrollbar>
        </div>
      </template>
    </template>
  </UserCenter>
  <el-dialog
    v-model="isShowPaymentPasswordDialog"
    :show-close="false"
    :close-on-click-modal="false"
    width="40%"
    custom-class="no-header"
  >
    <div class="mb-4" style="word-break: break-word">
      {{ alertMessage }}
    </div>
    <div>
      <el-form
        ref="ruleFormRef"
        label-position="left"
        label-width="200px"
        :model="formData"
        :rules="getRule"
        style="max-width: 550px"
        :validate-on-rule-change="false"
      >
        <el-form-item :label="paymentPasswordLabel" prop="paymentPassword">
          <el-input v-model="formData.paymentPassword" type="password" />
        </el-form-item>
        <el-form-item
          :label="confirmPaymentPasswordLabel"
          prop="confirmPaymentPassword"
        >
          <el-input v-model="formData.confirmPaymentPassword" type="password" />
        </el-form-item>
        <el-form-item :label="loginPasswordLabel" prop="loginPassword">
          <el-input v-model="formData.loginPassword" type="password" />
        </el-form-item>
      </el-form>
    </div>
    <template #footer>
      <span class="dialog-footer">
        <div class="text-center">
          <el-button type="danger" round @click="onCancel">{{
            $t("cancel")
          }}</el-button>
          <el-button
            type="primary"
            round
            @click="submitWithdrawal(ruleFormRef)"
            >{{ $t("submit") }}</el-button
          >
        </div>
      </span>
    </template>
  </el-dialog>
</template>

<script lang="ts" setup>
import UserCenter from "@/components/theme/desktop/peru/components/user-center-layout.client.vue";
import commonHelper from "@/utils/commonHelper";
import { store } from "~~/store";

const {
  paymentBanks,
  normalBanks,
  isNormalBankMethodValible,
  isPaymentBankMethodValible,
  paymentPasswordLabel,
  confirmPaymentPasswordLabel,
  loginPasswordLabel,
  alertMessage,
  formData,
  isShowPaymentPasswordDialog,
  submitWithdrawal,
  getRule,
  ruleFormRef,
  isPaymentPasswordEnable,
  profile,
  isWithdrawalLimitEnabled,
  isLoading,
  isBankMethodAvailabled,
  onCancel,
  isUfun,
} = useWithdrawal();
const { getAssetImage } = commonHelper;
const isSbo = computed(() => store.state.selectedThemeName === "sbo");
</script>
<style scoped>
.uc-section :deep(.el-input__inner),
.uc-section :deep(.el-input.is-disabled .el-input__inner),
.uc-section :deep(.el-input-group__append) {
  background-color: rgba(0, 0, 0, 0.1);
  color: var(--text5);
}
:deep(.company-bank-account .el-input__wrapper) {
  width: 98%;
}
.uc-section :deep(.company-bank-account-container .el-input-group__append) {
  background-color: var(--primary);
  border: unset;
  border-radius: 4px;
  box-shadow: none;
}
.uc-section :deep(.el-form-item__label) {
  color: var(--text5);
  font-size: 14px;
}
:deep(.el-radio-button .check-img) {
  bottom: 17px;
}
.show_hidden_button_left {
  display: none;
}
.show_hidden_button_right {
  display: block;
  --selected-border-color: #eee;
}
:deep(.check-btn__content) {
  min-width: fit-content;
}

@media screen and (min-width: 1536px) and (max-width: 1280px) {
  .show_hidden_button_left {
    display: none;
  }
  .show_hidden_button_right {
    display: block;
  }
  .customePeru .horizonal-line{
    border-right: 2px solid var(--border);
  }
  .check-btn__img {
    display: block;
  }
}
@media screen and (min-width: 1024px) and (max-width: 1279px) {
  .show_hidden_button_left {
    border-bottom: 2px solid var(--border);
    display: block;
  }
  .show_hidden_button_right {
    display: none;
  }
  .customePeru .horizonal-line{
    border-right: none;
  }
  .check-btn__img {
    display: block;
  }
  .cus_check_button {
    padding: 18px;
  }
}
@media screen and (min-width: 769px) and (max-width: 1023px) {
  .show_hidden_button_left {
    border-bottom: 2px solid var(--border);
    display: block;
  }
  .show_hidden_button_right {
    display: none;
  }
  .customePeru .horizonal-line{
    border-right: none;
  }
  .check-btn__img {
    display: block;
  }
  .cus_check_button {
    padding: 18px;
  }
}
@media screen and (min-width: 640px) and (max-width: 768px) {
  .show_hidden_button_left {
    border-bottom: 2px solid var(--border);
    display: block;
  }
  .show_hidden_button_right {
    display: none;
  }
  .customePeru .horizonal-line{
    border-right: none;
  }
  .display_none {
    display: block !important;
  }
  .check-btn__img {
    display: block;
  }
  .cus_check_button {
    padding: 18px;
    flex-flow: wrap;
  }
}

@media (max-width: 639px) {
  .show_hidden_button_left {
    display: block;
  }
  .show_hidden_button_right {
    display: none;
  }
  .customePeru .horizonal-line{
    border-right: none;
  }
  .display_none {
    display: none !important;
  }
  .display_bloc {
    display: block;
  }
  .check-btn__img {
    display: none;
  }
  :deep(.check-btn__content) {
    padding: 10px 30px !important;
  }
  .selected .check-btn ::before {
    --selected-border-color: color(--primary);
    border-bottom: 1px solid;
  }
  .check-btn::before {
    border: none;
    border-bottom: 2px solid transparent;
  }
  .check-btn {
    --border-radius: 0px;
    --border-color: transparent;
  }
  .check-btn__check {
    display: none;
  }
  .check-btn__img {
    display: none;
  }
  .cus_check_button {
    padding: 0px;
    justify-content: center;
    position: relative;
    transition: transform 0.3s;
    transition: transform var(--el-transition-duration);
    white-space: nowrap;
    z-index: 2;
    z-index: calc(var(--el-index-normal) + 1);
  }
  .cus_check_button:before {
    content: "";
    position: absolute;
    bottom: 0;
    left: 0;
    width: 100%;
    height: 2px;
    background: #505451;
  }
  .menu-header {
    --selected: var(--primary);
  }
}
.menu-header {
  overflow-x: auto;
  --selected: var(--primary);
}
:deep(.el-select .el-input .el-select__caret) {
  transform: rotateZ(0deg);
}
:deep(.el-select .el-input .el-select__caret.is-reverse) {
  transform: rotateZ(180deg);
}
</style>
